diff -uNrd ircd-ratbox-1.1rc4/include/Makefile ircd-7+BgFree-p6/include/Makefile
--- ircd-ratbox-1.1rc4/include/Makefile	Wed Dec 31 19:00:00 1969
+++ ircd-7+BgFree-p6/include/Makefile	Sun Apr  6 06:53:27 2003
@@ -0,0 +1,33 @@
+# Generated automatically from Makefile.in by configure.
+# $Id: Makefile.in,v 1.6 2002/11/21 21:18:22 leeh Exp $
+# makefile for include/
+
+INSTALL=	/usr/bin/install -c
+INSTALL_DATA=	${INSTALL} -m 644
+INSTALL_BIN=	${INSTALL}
+RM=		/bin/rm
+
+prefix=		/home/zer0c00l/ircd/
+exec_prefix=	${prefix}
+bindir=		${exec_prefix}/bin
+sysconfdir=	${prefix}/etc
+
+all:
+build:
+clean:
+depend:
+lint:
+
+install:
+	@echo installing header files...
+	-@if test ! -d $(prefix)/include; then \
+		echo "mkdir $(prefix)/include"; \
+		mkdir $(prefix)/include; \
+		mkdir $(prefix)/include/ircd-ratbox-7; \
+	fi
+	@for header in *.h; do \
+		${INSTALL_DATA} $$header $(prefix)/include/ircd-ratbox-7; \
+	done
+
+distclean:
+	${RM} -f Makefile
diff -uNrd ircd-ratbox-1.1rc4/include/channel_mode.h ircd-7+BgFree-p6/include/channel_mode.h
--- ircd-ratbox-1.1rc4/include/channel_mode.h	Fri Feb  7 12:56:33 2003
+++ ircd-7+BgFree-p6/include/channel_mode.h	Sun Apr  6 00:26:59 2003
@@ -80,6 +80,7 @@
 #define MODE_EXCEPTION  0x0800
 #define MODE_INVEX	0x2000
 #define MODE_HIDEOPS    0x4000
+#define MODE_NOCOLOR    0x1000
 
 /*
  * mode flags which take another parameter (With PARAmeterS)
@@ -98,6 +99,8 @@
 #define ParanoidChannel(x)	((x) && ((x)->mode.mode &\
 			        (MODE_PRIVATE|MODE_INVITEONLY))==\
 		                (MODE_PRIVATE|MODE_INVITEONLY))
+
+#define NoColorChannel(x)       ((x) && ((x)->mode.mode & MODE_NOCOLOR))
 
 struct ChModeChange
 {
diff -uNrd ircd-ratbox-1.1rc4/include/client.h ircd-7+BgFree-p6/include/client.h
--- ircd-ratbox-1.1rc4/include/client.h	Mon Jan 27 13:58:44 2003
+++ ircd-7+BgFree-p6/include/client.h	Sat Apr  5 19:25:31 2003
@@ -129,6 +129,8 @@
 	unsigned int flags;	/* client flags */
 	unsigned int flags2;	/* ugh. overflow */
 
+	unsigned int      svsflags;   /* services flags -zer0c00l */
+
 	int hopcount;		/* number of servers to this 0 = local */
 	unsigned short status;	/* Client type */
 	unsigned char handler;	/* Handler index */
@@ -384,6 +386,9 @@
 #define UMODE_OPER         0x20000	/* Operator */
 #define UMODE_ADMIN        0x40000	/* Admin on server */
 
+#define FLAGS_SVS_IDENT    0x00100  /* client has identified with services -zer0c00l */
+#define FLAGS_SVS_ADMIN    0x00200  /* client has identified as services admin -zer0c00l */
+
 #define UMODE_ALL	   UMODE_SERVNOTICE
 
 
@@ -497,6 +502,14 @@
 
 #define SetGotId(x)             ((x)->flags |= FLAGS_GOTID)
 #define IsGotId(x)              (((x)->flags & FLAGS_GOTID) != 0)
+
+#define IsNSId(x)               ((x)->svsflags & FLAGS_SVS_IDENT)
+#define SetNSId(x)              ((x)->svsflags |= FLAGS_SVS_IDENT)
+#define ClearNSId(x)            ((x)->svsflags &= ~FLAGS_SVS_IDENT)
+
+#define IsOSId(x)               ((x)->svsflags & FLAGS_SVS_ADMIN)
+#define SetOSId(x)              ((x)->svsflags |= FLAGS_SVS_ADMIN)
+#define ClearOSId(x)            ((x)->svsflags &= ~FLAGS_SVS_ADMIN)
 
 /*
  * flags2 macros.
diff -uNrd ircd-ratbox-1.1rc4/include/modules.h ircd-7+BgFree-p6/include/modules.h
--- ircd-ratbox-1.1rc4/include/modules.h	Wed Feb  5 20:47:35 2003
+++ ircd-7+BgFree-p6/include/modules.h	Sat Apr  5 18:07:09 2003
@@ -138,6 +138,7 @@
 extern struct Message squit_msgtab;
 extern struct Message stats_msgtab;
 extern struct Message svinfo_msgtab;
+extern struct Message svshint_msgtab;
 extern struct Message testline_msgtab;
 extern struct Message time_msgtab;
 extern struct Message topic_msgtab;
diff -uNrd ircd-ratbox-1.1rc4/include/numeric.h ircd-7+BgFree-p6/include/numeric.h
--- ircd-ratbox-1.1rc4/include/numeric.h	Sun Jan  5 18:54:55 2003
+++ ircd-7+BgFree-p6/include/numeric.h	Sat Apr  5 18:37:14 2003
@@ -117,6 +117,9 @@
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
 
+#define RPL_IDENTUSERS       267        /* for showing id users -zer0c00l */
+#define RPL_OSIDUSERS        268	/* for showin' S admins -zer0c00l */
+
 #define RPL_ACCEPTLIST	     281
 #define RPL_ENDOFACCEPT      282
 
@@ -130,7 +133,7 @@
 #define RPL_UNAWAY           305
 #define RPL_NOWAWAY          306
 
-/*      RPL_WHOISADMIN       308 -- hybrid */
+#define RPL_WHOISADMIN       308        /* is a Server Administrator" */
 
 #define RPL_WHOISUSER        311
 #define RPL_WHOISSERVER      312
@@ -151,6 +154,9 @@
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
 
+#define RPL_WHOISSVSHINT     326           /* identified with services -zer0c00l */
+#define RPL_OS_ID            327        /* identified as a services admin -zer0c00l */
+
 #define RPL_CREATIONTIME     329
 
 #define RPL_NOTOPIC          331
@@ -219,6 +225,8 @@
 #define ERR_NOTEXTTOSEND     412
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
+
+#define ERR_SERV_NICK        415        /* error deoping service nick -zer0c00l */
 
 #define ERR_TOOMANYMATCHES   416
 
diff -uNrd ircd-ratbox-1.1rc4/include/patchlevel.h ircd-7+BgFree-p6/include/patchlevel.h
--- ircd-ratbox-1.1rc4/include/patchlevel.h	Wed Feb 19 08:03:39 2003
+++ ircd-7+BgFree-p6/include/patchlevel.h	Sun Apr  6 00:22:17 2003
@@ -25,5 +25,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "ircd-ratbox-1.1rc4"
+#define PATCHLEVEL   "ircd-7+BgFree-p6"
 #endif
diff -uNrd ircd-ratbox-1.1rc4/include/s_misc.h ircd-7+BgFree-p6/include/s_misc.h
--- ircd-ratbox-1.1rc4/include/s_misc.h	Sun Jan  5 18:54:55 2003
+++ ircd-7+BgFree-p6/include/s_misc.h	Sun Apr  6 00:27:57 2003
@@ -42,5 +42,9 @@
 #define _GMKv(x)  ( (x > _1TER) ? (float)(x/_1TER) : ((x > _1GIG) ? \
                (float)(x/_1GIG) : ((x > _1MEG) ? (float)(x/_1MEG) : (float)x)))
 
+/* for services' nicks -zer0c00l */
+extern long     s_check( char * szName );
+
+extern char *strip_color(const char *, int);
 
 #endif
diff -uNrd ircd-ratbox-1.1rc4/include/s_serv.h ircd-7+BgFree-p6/include/s_serv.h
--- ircd-ratbox-1.1rc4/include/s_serv.h	Wed Feb  5 20:47:35 2003
+++ ircd-7+BgFree-p6/include/s_serv.h	Sat Apr  5 18:24:13 2003
@@ -252,6 +252,11 @@
 extern int MaxClientCount;	/* GLOBAL - highest number of clients */
 extern int MaxConnectionCount;	/* GLOBAL - highest number of connections */
 
+extern int CurrentIdentUsers;  /* Currently identified users to services -zer0c00l */
+extern int MaxIdentUsers;  /* Max identified users to services -zer0c00l */
+extern int CurrentOSidUsers; /* identified S admins -zer0c00l */
+extern int MaxOSidUsers;     /* maximum value */
+
 extern int refresh_user_links;
 
 /*
diff -uNrd ircd-ratbox-1.1rc4/include/serno.h ircd-7+BgFree-p6/include/serno.h
--- ircd-ratbox-1.1rc4/include/serno.h	Wed Feb 19 08:03:40 2003
+++ ircd-7+BgFree-p6/include/serno.h	Sun Apr  6 00:22:00 2003
@@ -1 +1 @@
-#define SERIALNUM "20030219_0"
+#define SERIALNUM "20030404_0"
diff -uNrd ircd-ratbox-1.1rc4/modules/.depend ircd-7+BgFree-p6/modules/.depend
--- ircd-ratbox-1.1rc4/modules/.depend	Tue Nov 12 23:49:15 2002
+++ ircd-7+BgFree-p6/modules/.depend	Sat Apr  5 18:08:05 2003
@@ -485,6 +485,15 @@
  ../include/s_conf.h ../include/motd.h ../include/class.h \
  ../include/s_log.h ../include/msg.h ../include/parse.h \
  ../include/modules.h
+m_svshint.o: m_svshint.c ../include/handlers.h ../include/client.h \
+ ../include/config.h ../include/setup.h ../include/ircd_defs.h \
+ ../include/ircd_handler.h ../include/linebuf.h ../include/tools.h \
+ ../include/channel.h ../include/res.h ../include/fileio.h \
+ ../include/../adns/adns.h ../include/ircd.h ../include/memory.h \
+ ../include/irc_string.h ../include/sprintf_irc.h ../include/common.h \
+ ../include/numeric.h ../include/send.h ../include/s_conf.h \
+ ../include/motd.h ../include/class.h ../include/s_log.h \
+ ../include/msg.h ../include/parse.h ../include/modules.h
 m_testline.o: m_testline.c ../include/stdinc.h ../include/config.h \
  ../include/setup.h ../include/defaults.h ../include/handlers.h \
  ../include/client.h ../include/ircd_defs.h ../include/ircd_handler.h \
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_kick.c ircd-7+BgFree-p6/modules/core/m_kick.c
--- ircd-ratbox-1.1rc4/modules/core/m_kick.c	Tue Feb  4 16:14:20 2003
+++ ircd-7+BgFree-p6/modules/core/m_kick.c	Sat Apr  5 18:19:21 2003
@@ -163,6 +163,14 @@
 		return;
 	}
 
+/* if a user tries to kick services' nick halt -zer0c00l */
+
+        if (s_check(user)) {
+             sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, parv[0], user);
+             return;
+        }
+
 	if(IsMember(who, chptr))
 	{
 		/* jdc
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_kill.c ircd-7+BgFree-p6/modules/core/m_kill.c
--- ircd-ratbox-1.1rc4/modules/core/m_kill.c	Wed Feb  5 20:47:37 2003
+++ ircd-7+BgFree-p6/modules/core/m_kill.c	Sat Apr  5 18:21:24 2003
@@ -160,9 +160,14 @@
 		target_p->flags |= FLAGS_KILLED;
 	}
 
-	ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
+if (MyOper(source_p) && MyConnect(target_p)) {
+    ircsprintf(buf, "Local kill by %s (%s)", source_p->name, reason);
+}
+else {
+  ircsprintf(buf, "Killed (%s (%s))", source_p->name, reason);
+  }
 
-	exit_client(client_p, target_p, source_p, buf);
+  exit_client(client_p, target_p, source_p, buf);
 }
 
 /*
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_message.c ircd-7+BgFree-p6/modules/core/m_message.c
--- ircd-ratbox-1.1rc4/modules/core/m_message.c	Wed Feb  5 20:47:37 2003
+++ ircd-7+BgFree-p6/modules/core/m_message.c	Sun Apr  6 00:39:20 2003
@@ -32,6 +32,7 @@
 #include "common.h"
 #include "s_conf.h"
 #include "s_serv.h"
+#include "s_misc.h"
 #include "send.h"
 #include "msg.h"
 #include "parse.h"
@@ -438,6 +439,9 @@
 		if(result == CAN_SEND_OPV ||
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
 		{
+		if (NoColorChannel(chptr))
+        	   text = strip_color(text, 0);
+	
 			sendto_channel_butone(client_p, source_p, chptr, command, ":%s", text);
 		}
 	}
diff -uNrd ircd-ratbox-1.1rc4/modules/core/m_nick.c ircd-7+BgFree-p6/modules/core/m_nick.c
--- ircd-ratbox-1.1rc4/modules/core/m_nick.c	Sun Jan  5 18:55:00 2003
+++ ircd-7+BgFree-p6/modules/core/m_nick.c	Sat Apr  5 18:03:43 2003
@@ -700,6 +700,14 @@
 
 	/* remove all accepts pointing to the client */
 	del_all_accepts(source_p);
+if (IsNSId(source_p)) {
+        CurrentIdentUsers--;
+
+        if (CurrentIdentUsers < 0)
+                CurrentIdentUsers= 0;
+
+        }
+        ClearNSId(source_p);
 
 	return 0;
 }
diff -uNrd ircd-ratbox-1.1rc4/modules/m_admin.c ircd-7+BgFree-p6/modules/m_admin.c
--- ircd-ratbox-1.1rc4/modules/m_admin.c	Wed Feb  5 20:47:36 2003
+++ ircd-7+BgFree-p6/modules/m_admin.c	Sun Apr  6 07:41:34 2003
@@ -110,6 +110,11 @@
 			return;
 	}
 
+if (IsPerson(source_p))
+    sendto_realops_flags(UMODE_SPY, L_ALL,
+                         "ADMIN requested by %s (%s@%s) [%s]", source_p->name,
+                         source_p->username, source_p->host, source_p->user->server); 
+
 	do_admin(source_p);
 }
 
@@ -127,6 +132,12 @@
 
 	if(IsClient(source_p))
 		do_admin(source_p);
+
+if (IsPerson(source_p))
+    sendto_realops_flags(UMODE_SPY, L_ALL,
+                         "ADMIN requested by %s (%s@%s) [%s]", source_p->name,
+                         source_p->username, source_p->host, source_p->user->server);
+
 }
 
 
diff -uNrd ircd-ratbox-1.1rc4/modules/m_links.c ircd-7+BgFree-p6/modules/m_links.c
--- ircd-ratbox-1.1rc4/modules/m_links.c	Wed Feb  5 20:47:36 2003
+++ ircd-7+BgFree-p6/modules/m_links.c	Sun Apr  6 13:32:26 2003
@@ -95,7 +95,14 @@
 	sendto_one(source_p, form_str(RPL_LINKS), me.name, parv[0], me.name, me.name, 0, me.info);
 
 	sendto_one(source_p, form_str(RPL_ENDOFLINKS), me.name, parv[0], "*");
-}
+
+/* if (MyConnect(source_p))
+    sendto_realops_flags(UMODE_SPY, L_ALL,
+                       "LINKS requested by %s (%s@%s) [%s]",
+                       source_p->name, source_p->username,
+                       source_p->host, source_p->user->server); */
+
+} 
 
 static void
 mo_links(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
diff -uNrd ircd-ratbox-1.1rc4/modules/m_stats.c ircd-7+BgFree-p6/modules/m_stats.c
--- ircd-ratbox-1.1rc4/modules/m_stats.c	Fri Feb  7 13:27:04 2003
+++ ircd-7+BgFree-p6/modules/m_stats.c	Sun Apr  6 07:41:59 2003
@@ -251,6 +251,15 @@
 
 	if((statchar != 'L') && (statchar != 'l'))
 		stats_spy(source_p, statchar);
+
+sendto_realops_flags(UMODE_SPY, L_ALL,
+                "STATS %c requested by %s (%s@%s) [%s]",
+                statchar,
+                source_p->name,
+                source_p->username,
+                source_p->host,
+                source_p->user->server); 
+
 }
 
 /*
@@ -303,6 +312,15 @@
 
 	if((statchar != 'L') && (statchar != 'l'))
 		stats_spy(source_p, statchar);
+
+sendto_realops_flags(UMODE_SPY, L_ALL,
+                "STATS %c requested by %s (%s@%s) [%s]",
+                statchar,
+                source_p->name,
+                source_p->username,
+                source_p->host,
+                source_p->user->server);
+
 }
 
 
diff -uNrd ircd-ratbox-1.1rc4/modules/m_svshint.c ircd-7+BgFree-p6/modules/m_svshint.c
--- ircd-ratbox-1.1rc4/modules/m_svshint.c	Wed Dec 31 19:00:00 1969
+++ ircd-7+BgFree-p6/modules/m_svshint.c	Sat Apr  5 19:47:46 2003
@@ -0,0 +1,110 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_version.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svshint.c,v 1.3 2003/04/04 03:16:20 zer0c00l Exp $
+ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* TRUE bleah */
+#include "irc_string.h"
+#include "ircd.h"
+#include "hash.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+static void ms_svshint(struct Client*, struct Client*, int, char**);
+
+struct Message svshint_msgtab = {
+  "SVSHINT", 0, 1, 0, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svshint, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svshint_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svshint_msgtab);
+}
+
+char *_version = "20030404";
+#endif
+/*
+ * ms_svshint - SVSHINT command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = hint flags
+ *      parv[2] = nick
+ */
+static void ms_svshint(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+  unsigned int hint;
+
+victim = find_client(parv[2]);
+
+/* zer0c00l was here */
+
+if (!IsServer(source_p))
+        return;
+
+	if (!(victim)) 
+		return;
+
+  if (!strcasecmp(parv[1], "NSID") && !IsNSId(victim)) {
+                SetNSId(victim);
+                CurrentIdentUsers++;
+                
+		if (CurrentIdentUsers > MaxIdentUsers)
+                    MaxIdentUsers = CurrentIdentUsers;
+		
+  sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+                ":%s SVSHINT NSID %s 1", me.name, victim->name);
+	   		return;
+        }
+
+  if (!strcasecmp(parv[1], "OSID") && !IsOSId(victim)) {
+                SetOSId(victim);
+		CurrentOSidUsers++;
+
+                if (CurrentOSidUsers > MaxOSidUsers)
+                    MaxOSidUsers = CurrentOSidUsers;
+               
+  sendto_server(client_p, NULL, NOCAPS, NOCAPS,
+                ":%s SVSHINT OSID %s 1", me.name, victim->name);
+                        return;
+        }
+
+}
diff -uNrd ircd-ratbox-1.1rc4/modules/m_users.c ircd-7+BgFree-p6/modules/m_users.c
--- ircd-ratbox-1.1rc4/modules/m_users.c	Sun Jan  5 18:54:58 2003
+++ ircd-7+BgFree-p6/modules/m_users.c	Sat Apr  5 18:25:38 2003
@@ -80,6 +80,12 @@
 
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 		   Count.total, Count.max_tot);
+
+ sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
+
+        sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+                 CurrentOSidUsers, MaxOSidUsers);
 }
 
 /*
@@ -101,5 +107,11 @@
 
 		sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 			   Count.total, Count.max_tot);
+
+sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
+
+        sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+                 CurrentOSidUsers, MaxOSidUsers);
 	}
 }
diff -uNrd ircd-ratbox-1.1rc4/modules/m_wallops.c ircd-7+BgFree-p6/modules/m_wallops.c
--- ircd-ratbox-1.1rc4/modules/m_wallops.c	Sat Jan 18 08:08:08 2003
+++ ircd-7+BgFree-p6/modules/m_wallops.c	Sat Apr  5 19:34:36 2003
@@ -78,7 +78,7 @@
 		return;
 	}
 
-	sendto_wallops_flags(UMODE_OPERWALL, source_p, "OPERWALL - %s", message);
+	sendto_wallops_flags(UMODE_OPERWALL, source_p, "WALLOPS - %s", message);
 	sendto_server(NULL, NULL, NOCAPS, NOCAPS, ":%s WALLOPS :%s", parv[0], message);
 }
 
@@ -101,7 +101,7 @@
 	}
 
 	if(IsClient(source_p))
-		sendto_wallops_flags(UMODE_OPERWALL, source_p, "OPERWALL - %s", message);
+		sendto_wallops_flags(UMODE_OPERWALL, source_p, "WALLOPS - %s", message);
 	else
 		sendto_wallops_flags(UMODE_WALLOP, source_p, "%s", message);
 
diff -uNrd ircd-ratbox-1.1rc4/modules/m_whois.c ircd-7+BgFree-p6/modules/m_whois.c
--- ircd-ratbox-1.1rc4/modules/m_whois.c	Wed Feb  5 20:47:36 2003
+++ ircd-7+BgFree-p6/modules/m_whois.c	Sat Apr  5 19:34:11 2003
@@ -353,6 +353,19 @@
 	int reply_to_send = NO;
 	struct hook_mfunc_data hd;
 
+/* checkin' if target_p is a service -zer0c00l */
+
+if (s_check(target_p->name)) {
+         sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
+         source_p->name, target_p->name,
+         target_p->username, target_p->host, target_p->info);
+          sendto_one(source_p, form_str(RPL_WHOISSERVER),
+               me.name, source_p->name, target_p->name,
+               ServerInfo.network_name,
+               ServerInfo.network_desc);
+        return;
+}
+
 	a2client_p = find_server(target_p->user->server);
 
 	sendto_one(source_p, form_str(RPL_WHOISUSER), me.name,
@@ -360,6 +373,16 @@
 		   target_p->username, target_p->host, target_p->info);
 	server_name = (char *) target_p->user->server;
 
+if (IsNSId(target_p)) {
+         sendto_one(source_p, form_str(RPL_WHOISSVSHINT), me.name,
+               source_p->name, target_p->name);
+}
+
+        if (IsOSId(target_p)) {
+           sendto_one(source_p, form_str(RPL_OS_ID),
+                      me.name, source_p->name, target_p->name);
+}
+
 	ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name, "");
 
 	mlen = strlen(buf);
@@ -420,6 +443,10 @@
 		sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
 			   me.name, source_p->name, target_p->name);
 	}
+
+ 	if (IsAdmin(target_p))
+        sendto_one(source_p, form_str(RPL_WHOISADMIN),
+                   me.name, source_p->name, target_p->name);
 
 	if(MyClient(target_p))
 	{
diff -uNrd ircd-ratbox-1.1rc4/src/channel_mode.c ircd-7+BgFree-p6/src/channel_mode.c
--- ircd-ratbox-1.1rc4/src/channel_mode.c	Sun Feb  9 14:37:43 2003
+++ ircd-7+BgFree-p6/src/channel_mode.c	Sun Apr  6 00:32:56 2003
@@ -381,6 +381,8 @@
 		*mbuf++ = 'i';
 	if(chptr->mode.mode & MODE_NOPRIVMSGS)
 		*mbuf++ = 'n';
+	if (chptr->mode.mode & MODE_NOCOLOR)
+    		*mbuf++ = 'c';
 
 	if(chptr->mode.limit)
 	{
@@ -1066,6 +1068,14 @@
 		return;
 	}
 
+/* added for protecting services' nicks -zer0c00l */
+if ((dir == MODE_DEL) && s_check(opnick))
+{
+        sendto_one(source_p, form_str(ERR_SERV_NICK),
+                 me.name, source_p->name, opnick);
+             return;
+}
+	
 	if(MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
 		return;
 
@@ -1319,7 +1329,7 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},				  /* a */
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
diff -uNrd ircd-ratbox-1.1rc4/src/client.c ircd-7+BgFree-p6/src/client.c
--- ircd-ratbox-1.1rc4/src/client.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/client.c	Sun Apr  6 00:11:09 2003
@@ -57,6 +57,7 @@
 #include "balloc.h"
 #include "listener.h"
 
+#define SERVICESHOST	"united.bgfree.services"
 
 static void check_pings_list(dlink_list * list);
 static void check_unknowns_list(dlink_list * list);
@@ -801,6 +802,20 @@
 			--Count.oper;
 		if(IsInvisible(client_p))
 			--Count.invisi;
+
+if (IsNSId(client_p)) {
+        CurrentIdentUsers--;
+        if (CurrentIdentUsers < 0) {
+        CurrentIdentUsers = 0;
+                        }
+                }
+ if (IsOSId(client_p)) {
+        CurrentOSidUsers--;
+        if (CurrentOSidUsers < 0) {
+        CurrentOSidUsers = 0;
+                        }
+                }
+
 	}
 
 	if(splitchecking && !splitmode)
@@ -1099,6 +1114,21 @@
 		   (source_p->flags & FLAGS_KILLED) == 0)
 			sendto_one(target_p, ":%s SQUIT %s :%s", from->name, source_p->name,
 				   comment);
+if (!strcasecmp(SERVICESHOST, source_p->name)) {
+           dlink_node *ptr;
+	
+            CurrentIdentUsers = 0;
+            CurrentOSidUsers = 0;
+           for (ptr = global_client_list.head; ptr; ptr = ptr->next) {
+	target_p = ptr->data;
+               if (IsServer(target_p) || IsMe(target_p))
+                    continue;
+               if (IsNSId(target_p))
+                   ClearNSId(target_p);
+              if (IsOSId(target_p))
+                   ClearOSId(target_p);
+             } 
+        }
 	}
 	else if(IsPerson(source_p))	/* ...just clean all others with QUIT... */
 	{
@@ -1819,6 +1849,14 @@
 	 */
 
 	del_all_accepts(source_p);
+if (IsNSId(source_p)) {
+        CurrentIdentUsers--;
+
+        if (CurrentIdentUsers < 0)
+                CurrentIdentUsers= 0;
+
+        }
+  ClearNSId(source_p);
 
 	/* fd_desc is long enough */
 	fd_note(client_p->localClient->fd, "Nick: %s", nick);
diff -uNrd ircd-ratbox-1.1rc4/src/messages.tab ircd-7+BgFree-p6/src/messages.tab
--- ircd-ratbox-1.1rc4/src/messages.tab	Fri Feb  7 13:27:04 2003
+++ ircd-7+BgFree-p6/src/messages.tab	Sat Apr  5 18:34:48 2003
@@ -291,8 +291,8 @@
 /* 264 */       NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
-/* 267 */       NULL,
-/* 268 */       NULL,
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified users: %d  Max: %d",
+/* 268 RPL_OSIDUSERS, */        ":%s 268 %s :Current services admins: %d  Max: %d",
 /* 269 */       NULL,
 /* 270 */       NULL,
 /* 271 */       NULL,
@@ -332,7 +332,7 @@
 /* 305 RPL_UNAWAY, */   ":%s 305 %s :You are no longer marked as being away",
 /* 306 RPL_NOWAWAY, */  ":%s 306 %s :You have been marked as being away",
 /* 307 */       NULL,
-/* 308 */       NULL,
+/* 308 RPL_WHOISADMIN,  */      ":%s 308 %s %s :is a Server Administrator",
 /* 309 */       NULL,
 /* 310 */       NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
@@ -350,8 +350,8 @@
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
 /* 325 */       NULL,
-/* 326 */       NULL,
-/* 327 */       NULL,
+/* 326 RPL_WHOISSVSHINT, */     ":%s 326 %s %s :has identified for: this nick",
+/* 327 RPL_OS_ID, */            ":%s 327 %s %s :is a Network Administrator",
 /* 328 */       NULL,
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
 /* 330 */       NULL,
@@ -439,7 +439,7 @@
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
 /* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
-/* 415 */       NULL,
+/* 415 ERR_SERV_NICK, */        ":%s 415 %s %s :- You can not kick/deop services",
 /* 416 ERR_TOOMANYMATCHES */    ":%s 416 %s %s :output too large, truncated",
 /* 417 */       NULL,
 /* 418 */       NULL,
diff -uNrd ircd-ratbox-1.1rc4/src/modules.c ircd-7+BgFree-p6/src/modules.c
--- ircd-ratbox-1.1rc4/src/modules.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/modules.c	Sat Apr  5 18:09:32 2003
@@ -593,6 +593,7 @@
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
+        mod_add_cmd(&svshint_msgtab);
 	mod_add_cmd(&testline_msgtab);
 	mod_add_cmd(&time_msgtab);
 	mod_add_cmd(&topic_msgtab);
diff -uNrd ircd-ratbox-1.1rc4/src/s_misc.c ircd-7+BgFree-p6/src/s_misc.c
--- ircd-ratbox-1.1rc4/src/s_misc.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/s_misc.c	Sun Apr  6 00:34:17 2003
@@ -53,6 +53,36 @@
 	"Thursday", "Friday", "Saturday"
 };
 
+/* next few lines are the services' nicks.Modify as needed -zer0c00l */
+
+char* servnicks[] = {
+         "CS" ,
+         "OS" ,
+         "STATSERV" ,
+         "SEEN" ,
+         "SEENSERV" ,
+         "ADMINSERV" ,
+         "SPLITSERV"
+};
+#define ARR_SIZE 7 /* number of services' nicks.Increase or decrease as needed */
+
+/* s_check ()
+ * will verify that the nick to be kicked is not a service nick
+ * and stop if it is
+ *                              -zer0c00l
+ */
+
+long s_check( char * szName )
+{
+    int i = 0;
+    for( i=0;i<ARR_SIZE;i++)
+        if( !strcasecmp(szName, servnicks[i]))
+            return 1;
+    return 0;
+}
+
+/* end of s_check() */
+
 char *
 date(time_t lclock)
 {
@@ -125,3 +155,62 @@
 	strftime(timebuffer, MAX_DATE_STRING, "%Y%m%d", tmptr);
 	return timebuffer;
 }
+
+/* no color -zer0c00l */
+char *strip_color(const char *p, int b)
+{
+  static char buf[512];
+  char *r, *q = buf;
+  int m, n;
+
+  do switch (*p) {
+
+  case '\003':
+    p++; if (isdigit(*p)) {
+      p++; m = *p>='0' && *p<='6';
+      n = *(p-1)=='1' || *(p-1)=='0';
+      if (m && n) {
+        p++; if (*p == ',') {
+          p++; if (isdigit(*p)) {
+            p++; m = *p>='0' && *p<='6';
+            n = *(p-1)=='1' || *(p-1)=='0';
+            if (m && n) {
+              p++;
+            }
+          }
+        }
+      } else if (*p == ',') {
+        p++; if (isdigit(*p)) {
+          p++; m = *p>='0' && *p<='6';
+          n = *(p-1)=='1' || *(p-1)=='0';
+          if (m && n) {
+            p++;
+          }
+        }
+      }
+    }
+    break;
+
+  case '\033':
+    p++; if (*p == '[') {
+      p++; r = strchr(p, 'm');
+      if (r) p = r + 1;
+    }
+    break;
+
+  case '\002':
+  case '\037':
+    if (b) {
+      p++; break;
+    }
+
+  default:
+    *q++ = *p++;
+    break;
+
+  } while (*p);
+
+  *q = 0;
+  return buf;
+}
+
diff -uNrd ircd-ratbox-1.1rc4/src/s_serv.c ircd-7+BgFree-p6/src/s_serv.c
--- ircd-ratbox-1.1rc4/src/s_serv.c	Thu Feb 13 15:53:17 2003
+++ ircd-7+BgFree-p6/src/s_serv.c	Sat Apr  5 18:27:12 2003
@@ -73,6 +73,11 @@
 int MaxClientCount = 1;
 int refresh_user_links = 0;
 
+int CurrentIdentUsers  = 0;
+int MaxIdentUsers  = 0;
+int CurrentOSidUsers = 0;
+int MaxOSidUsers = 0;
+
 static void start_io(struct Client *server);
 static void burst_members(struct Client *client_p, dlink_list * list);
 
@@ -813,6 +818,13 @@
 			   ubuf,
 			   target_p->username, target_p->host,
 			   target_p->user->server, target_p->info);
+
+	 if (IsNSId(target_p))
+          sendto_one(client_p, "SVSHINT NSID %s 1", target_p->name);
+
+        if (IsOSId(target_p))
+        sendto_one(client_p, "SVSHINT OSID %s 1", target_p->name);
+
 }
 
 /*
diff -uNrd ircd-ratbox-1.1rc4/src/s_user.c ircd-7+BgFree-p6/src/s_user.c
--- ircd-ratbox-1.1rc4/src/s_user.c	Wed Feb  5 20:47:39 2003
+++ ircd-7+BgFree-p6/src/s_user.c	Sat Apr  5 18:27:54 2003
@@ -227,6 +227,12 @@
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
 		   Count.total, Count.max_tot);
 
+ sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, source_p->name,
+             CurrentIdentUsers, MaxIdentUsers);
+
+  sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, source_p->name,
+             CurrentOSidUsers, MaxOSidUsers);
+
 	if(!ConfigServerHide.hide_servers || IsOper(source_p))
 		sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
 			   MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
